<?php
/*
 +-------------------------------------------------------------------------+
 | Copyright (C) 2006 Reinhard Scheck aka gandalf                          |
 |                                                                         |
 | This program is free software; you can redistribute it and/or           |
 | modify it under the terms of the GNU General Public License             |
 | as published by the Free Software Foundation; either version 2          |
 | of the License, or (at your option) any later version.                  |
 |                                                                         |
 | This program is distributed in the hope that it will be useful,         |
 | but WITHOUT ANY WARRANTY; without even the implied warranty of          |
 | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           |
 | GNU General Public License for more details.                            |
 +-------------------------------------------------------------------------+
 */

chdir('../../');


include("./include/auth.php");
include_once("./lib/utility.php");

define("MAX_DISPLAY_PAGES", 21);
include_once("./include/top_header.php");
poller_perf();
include_once("./include/bottom_footer.php");

/* --------------------------
    Global Form Functions
   -------------------------- */

function poller_perf() {
	global $colors, $config;

	/* ================= input validation ================= */
	input_validate_input_number(get_request_var_request("host_id"));
	input_validate_input_number(get_request_var_request("page"));
	/* ==================================================== */

	/* clean up search string */
	if (isset($_REQUEST["filter"])) {
		$_REQUEST["filter"] = sanitize_search_string(get_request_var("filter"));
	}

	/* clean up sort_column string */
	if (isset($_REQUEST["sort_column"])) {
		$_REQUEST["sort_column"] = sanitize_search_string(get_request_var("sort_column"));
	}

	/* clean up sort_direction string */
	if (isset($_REQUEST["sort_direction"])) {
		$_REQUEST["sort_direction"] = sanitize_search_string(get_request_var("sort_direction"));
	}

	/* if the user pushed the 'clear' button */
	if (isset($_REQUEST["clear_x"])) {
		kill_session_var("sess_pollperf_current_page");
		kill_session_var("sess_pollperf_filter");
		kill_session_var("sess_pollperf_sort_column");
		kill_session_var("sess_pollperf_sort_direction");
		kill_session_var("sess_pollperf_host_id");

		unset($_REQUEST["page"]);
		unset($_REQUEST["filter"]);
		unset($_REQUEST["sort_column"]);
		unset($_REQUEST["sort_direction"]);
		unset($_REQUEST["host_id"]);
	}

	/* remember these search fields in session vars so we don't have to keep passing them around */
	load_current_session_value("page", "sess_pollperf_current_page", "1");
	load_current_session_value("filter", "sess_pollperf_filter", "");
	load_current_session_value("sort_column", "sess_pollperf_sort_column", "description");
	load_current_session_value("sort_direction", "sess_pollperf_sort_direction", "ASC");
	load_current_session_value("host_id", "sess_pollperf_host_id", "-1");

	$sortby = $_REQUEST["sort_column"];
	/* remember these fields in session vars so we don't have to keep passing them around */
	load_current_session_value("page", "sess_device_current_page", "1");

	/* generate page list */
	html_start_box("<strong>Poller Performance</strong>", "98%", $colors["header"], "3", "center", "");

	include("./plugins/pollperf/inc_pollperf_filter_table.php");

	html_end_box();

	/* form the 'where' clause for our main sql query */
	$sql_where = "WHERE (host.hostname LIKE '%%" . $_REQUEST["filter"] . "%%' OR host.description LIKE '%%" . $_REQUEST["filter"] . "%%')";

	html_start_box("", "98%", $colors["header"], "3", "center", "");

	/* fetch the hosts table
	 *  */
	$total_rows = db_fetch_cell("select
		COUNT(host.id)
		FROM host
		LEFT JOIN plugin_pollperf_data
		ON (host.id = plugin_pollperf_data.id)
		$sql_where");

	/* get $hosts() from MySql */
	$hosts = db_fetch_assoc("SELECT
		host.id,
		host.disabled,
		host.status,
		host.hostname,
		host.description,
		plugin_pollperf_data.lstart,
		plugin_pollperf_data.lend,
		plugin_pollperf_data.ds_count,
		plugin_pollperf_data.diff,
		plugin_pollperf_data.rate,
		plugin_pollperf_data.ds_per_run,
		plugin_pollperf_data.dur_per_run
		FROM host
		LEFT JOIN plugin_pollperf_data
		ON (host.id = plugin_pollperf_data.id)
		$sql_where"
		. " ORDER BY " . $_REQUEST["sort_column"] . " " . $_REQUEST["sort_direction"]
		. " LIMIT " . (read_config_option("num_rows_device")*($_REQUEST["page"]-1)) . "," . read_config_option("num_rows_device")
		);


	$url_page_select = get_page_list($_REQUEST["page"], MAX_DISPLAY_PAGES, read_config_option("num_rows_device"), $total_rows, "pollperf.php?");

	$nav = "<tr bgcolor='#" . $colors["header"] . "'>
			<td colspan='11'>
				<table width='100%' cellspacing='0' cellpadding='0' border='0'>
					<tr>
						<td align='left' class='textHeaderDark'>
							<strong>&lt;&lt; "; if ($_REQUEST["page"] > 1) { $nav .= "<a class='linkOverDark' href='pollperf.php?page=" . ($_REQUEST["page"]-1) . "'>"; } $nav .= "Previous"; if ($_REQUEST["page"] > 1) { $nav .= "</a>"; } $nav .= "</strong>
						</td>\n
						<td align='center' class='textHeaderDark'>
							Showing Rows " . ((read_config_option("num_rows_device")*($_REQUEST["page"]-1))+1) . " to " . ((($total_rows < read_config_option("num_rows_device")) || ($total_rows < (read_config_option("num_rows_device")*$_REQUEST["page"]))) ? $total_rows : (read_config_option("num_rows_device")*$_REQUEST["page"])) . " of $total_rows [$url_page_select]
						</td>\n
						<td align='right' class='textHeaderDark'>
							<strong>"; if (($_REQUEST["page"] * read_config_option("num_rows_device")) < $total_rows) { $nav .= "<a class='linkOverDark' href='pollperf.php?page=" . ($_REQUEST["page"]+1) . "'>"; } $nav .= "Next"; if (($_REQUEST["page"] * read_config_option("num_rows_device")) < $total_rows) { $nav .= "</a>"; } $nav .= " &gt;&gt;</strong>
						</td>\n
					</tr>
				</table>
			</td>
		</tr>\n";

	print $nav;

	$display_text = array(
		"description" 	=> array("Description", "ASC"),
		"status" 		=> array("Status", "ASC"),
		"hostname" 		=> array("Hostname", "ASC"),
		"lstart"	 	=> array("Last<br>Poller Start", "DESC"),
		"lend" 			=> array("Last<br>Poller End", "DESC"),
		"ds_count" 		=> array("#DS<br>Total", "DESC"),
		"diff" 			=> array("Duration<br>Total", "DESC"),
		"ds_per_run" 	=> array("#DS<br>per run", "DESC"),
		"dur_per_run" 	=> array("Duration<br>per run", "DESC"),
		"rate"		 	=> array("Duration<br>per DS", "DESC")
	);

	html_header_sort($display_text, $_REQUEST["sort_column"], $_REQUEST["sort_direction"]);

	
	$i = 0;
	if (sizeof($hosts) > 0) {
		foreach ($hosts as $host) {
			form_alternate_row_color($colors["alternate"],$colors["light"],$i); $i++;
				?>
				<td width=250><a
					class="linkEditMain"
					href="<?php print $config['url_path'];?>host.php?action=edit&id=<?php print $host["id"];?>"><?php print eregi_replace("(" . preg_quote($_REQUEST["filter"]) . ")", "<span style='background-color: #F8D93D;'>\\1</span>", $host["description"]);?></a>
				</td>
				<td><?php print get_colored_device_status(($host["disabled"] == "on" ? true : false), $host["status"]);?></td>
				<td><?php print eregi_replace("(" . preg_quote($_REQUEST["filter"]) . ")", "<span style='background-color: #F8D93D;'>\\1</span>", $host["hostname"]);?></td>
				<td><?php print (isset($host["lstart"]) 	? $host["lstart"] 		: "None");?></td>
				<td><?php print (isset($host["lend"]) 		? $host["lend"] 		: "None");?></td>
				<td><?php print (isset($host["ds_count"]) 	? $host["ds_count"] 	: "None");?></td>
				<td><?php print (isset($host["diff"]) 		? $host["diff"] 		: "None");?></td>
				<td><?php print (isset($host["ds_per_run"])	? $host["ds_per_run"]	: "None");?></td>
				<td><?php print (isset($host["diff"]) 		? $host["dur_per_run"]	: "None");?></td>
				<td><?php print (isset($host["rate"]) 		? $host["rate"]	 		: "None");?></td>
			</tr>
			<?php
		}

		/* put the nav bar on the bottom as well */
		print $nav;
	}else{
		print "<tr><td><em>No Hosts</em></td></tr>";
	}

	# some log file statistics
	$stats_found = read_config_option("plugin_pollperf_stats_found", TRUE);
	$poller_runs = read_config_option("plugin_pollperf_total_runs", TRUE);
	print "<tr><td>Poller Runs including Statistics: " . $stats_found . "</td><td>" . "Total Runs: " . $poller_runs . "</td></tr>";
	html_end_box(false);
}

?>
